/* ************************************************************************

   Copyright: 2024 

   License: MIT license

   Authors: 

************************************************************************ */

/**
 * This is the main application class of "prdemo"
 *
 * @asset(pmalinowskivmn/*)
 */
qx.Class.define("pmalinowskivmn.Application",
{
  extend : qx.application.Standalone,



  /*
  *****************************************************************************
     MEMBERS
  *****************************************************************************
  */

  members :
  {
    /**
     * This method contains the initial application code and gets called
     * during startup of the application
     *
     * @lint ignoreDeprecated(alert)
     */
    main()
    {
      // Call super class
      super.main();

      // Enable logging in debug variant
      if (qx.core.Environment.get("qx.debug"))
      {
        // support native logging capabilities, e.g. Firebug for Firefox
        qx.log.appender.Native;
        // support additional cross-browser console. Press F7 to toggle visibility
        qx.log.appender.Console;
      }

      /*
      -------------------------------------------------------------------------
        Below is your actual application code...
      -------------------------------------------------------------------------
      */

      function ThirdPartyClass() {
        this.name = "Mary";
        this.surname = "Berry";
      }

      ThirdPartyClass.prototype.getFullName = function() {
        return this.name + " " + this.surname;
      };

      ThirdPartyClass.prototype.properties = function() {
        return "This method is named like qooxdoo's top-level properties section, so will cause an error to be thrown";
      }

      let pojoToMarshal = {
        favouriteRecipe: "Victoria Sponge",
        author: new ThirdPartyClass()
      };

      // Create a button
      const button1 = new qx.ui.form.Button("Click me", "pmalinowskivmn/test.png");

      // Document is the application root
      const doc = this.getRoot();

      // Add button to document at fixed coordinates
      doc.add(button1, {left: 100, top: 50});

      // Add an event listener
      button1.addListener("execute", function() {
        /* eslint no-alert: "off" */
        try {
          let result = qx.data.marshal.Json.createModel(pojoToMarshal);          
          alert("Full name: " + result.getAuthor().getFullName() + "\nSurname: " + result.getAuthor().surname);
        } catch (e) {
          console.error(e);
          alert("Error. Please open console for details.");
        }
      });
    }
  }
});
